# Adversarial Insight ML

Adversarial Insight ML (AIML) is a PyPI package that evaluates the robustness of machine learning models in image classification against adversarial attacks. The final program in the package should automatically test potential adversarial attacks against each given machine learning model and give users accurate, efficient and robust feedback through several benchmarks we develop. Furthermore, the package should be designed to allow non-technical users to use it as well.

## Table of Contents

- [Installation](#installation)
- [Usage](#usage)
- [Features](#features)
- [Contributing](#contributing)
- [License](#license)

## Installation

Instructions on how to install and set up your project locally. Include any dependencies or requirements.

## Usage

Instructions on how to use your project. Provide examples or code snippets to demonstrate its functionality.

## Features

Highlight the key features or functionalities of your project. List them in a concise and easy-to-understand manner.

## Contributing

**Code Style**  
We adhere to the [PEP 8](https://www.python.org/dev/peps/pep-0008/) style guide for writing Python code. Consistent code formatting enhances readability and maintainability. Please ensure your code follows these conventions.

**Commit Messages**  
When making changes to the codebase, please refer to the [Documentation/SubmittingPatches](https://git.kernel.org/pub/scm/git/git.git/tree/Documentation/SubmittingPatches?h=v2.36.1#n181) in the Git repo:

- Write commit messages in present tense and imperative mood, e.g., "Add feature" instead of "Added feature" or "Adding feature."
- Craft your messages as if you're giving orders to the codebase to change its behaviour.
- Provide clear and concise summaries of your changes in the first line.
- If needed, add a more detailed description in the following lines.

## License

This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.

## Acknowledgements

We extend our sincere appreciation to the following individuals and groups who have been instrumental in the success of this project:

Firstly, our client Luke Chang. His invaluable guidance and insights guided us from the beginning through every phase, ensuring our work remained aligned with practical needs. This project would not have been possible without his efforts.

We'd also like to express gratitude to the teaching staff for COMPSCI 399 at The University of Auckland, including Dr Asma Shakil, who has coordinated and provided an opportunity for us to work together on this project.

Thank you for being part of this journey.

Warm regards,
Team 7

## Contact

Terence Zhang tzha820@aucklanduni.ac.nz  
Yuming Zhou yzho739@aucklanduni.ac.nz  
Sungjae Jang sjan260@aucklanduni.ac.nz  
Takuya Saegusa tsae032@aucklanduni.ac.nz  
Haozhe Wei hwei313@aucklanduni.ac.nz  
